.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm		; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

  buffersize	= 20000		; don't go higher than 100000, ml.exe would slow down
  LOOP_COUNT	= 100000
  srcalign	= 8-1		; try 7, 8 or 9
  destalign	= 8+1		; try 7, 8 or 9

ShowCpu	PROTO:DWORD

showaligned MACRO arg
LOCAL tmp$
  mov esi, eax
  mov edi, offset src
  mov eax, edi
  and eax, -16
  sub edi, eax
  tmp$ CATSTR <print str$(esi), 9, "cycles for >, <arg>, <", 9, "srcalign=">
  ;% echo tmp$
  tmp$
  print str$(edi), ", destalign="
  mov edi, offset dest
  mov eax, edi
  and eax, -16
  sub edi, eax
  print str$(edi), 13, 10
ENDM

.data
MyString	db "A 16 bytes text.", 0

.data?
align 16
src16	db srcalign dup(?)		
src	dd buffersize dup(?)
align 16
dest16	db destalign dup(?)		; try 7, 8 or 9
dest	dd buffersize dup(?)

.code
start:
	invoke ShowCpu, 1	; prints the brand string and returns SSE level in eax
	mov ebx, 100
	.Repeat
		invoke lstrcat, addr src, offset MyString
		dec ebx
	.Until Zero?
	REPEAT 3
	if 1
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset src16
		mov edi, offset dest16
		mov ecx, 100
		.Repeat
			movdqa xmm1, [esi]
			lea esi, [esi+16]
			movdqa [edi], xmm1
			lea edi, [edi+16]
			dec ecx
		.Until Zero?
	counter_end
	print str$(eax), 9, "cycles for movdqa             ", 9, "(src + dest aligned 16)", 13, 10
	endif

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset src
		mov edi, offset dest
		mov ecx, 100
		.Repeat
			movlps xmm0, qword ptr [esi]
			movlps qword ptr [edi], xmm0
			lea esi, [esi+16]
			movhps xmm0, qword ptr [esi-8]
			movhps qword ptr [edi+8], xmm0
			lea edi, [edi+16]
			dec ecx
		.Until Zero?
	counter_end
	; print offset dest, 13, 10		; we might test the output here
	showaligned <movlps/movhps>

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset src
		mov edi, offset dest
		mov ecx, 100
		.Repeat
			movdqu xmm1, [esi]
			lea esi, [esi+16]
			movdqu [edi], xmm1
			lea edi, [edi+16]
			dec ecx
		.Until Zero?
	counter_end
	showaligned <movdqu          >

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset src
		mov edi, offset dest
		mov ecx, 400
		rep movsd
	counter_end
	showaligned <rep movsd      >

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov esi, offset src
		mov edi, offset dest
		ffree st(7)
		mov ecx, 200
		.Repeat
			fild qword ptr [esi]
			lea esi, [esi+8]
			fistp qword ptr [edi]
			lea edi, [edi+8]
			dec ecx
		.Until Zero?
	counter_end
	showaligned <fild/fistp     >

	print chr$(10)
	ENDM

	inkey chr$(13, 10, "--- ok ---", 13)
	exit
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
ShowCpu proc mode:DWORD
COMMENT	@ Usage: 
Move this line up:
ShowCpu	PROTO:DWORD

	invoke ShowCpu, 0		; simple, no printing, just returns SSE level
	invoke ShowCpu, 1		; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp
ShowCpue:

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

end start

RichMasm options:
OxPT_Linker	link	; If present in \bin, PoLink.exe will be used; delete the x to force link.exe
OxPT_Assembler	ml	; If present in \bin, JWasm.exe will be used; delete the x to force link.exe
OPT_DebugL	/MERGE:.data=.rdata /MERGE:.rdata=.text	; for ultra short executables
OPT_NoWarn	LNK4254, multiple	; we ignore linker warnings found in this string, e.g. section a merged into b with different attributes
OPT_WAIT	0		; wait until a key is pressed before closing the DOS box
OPT_Tmp2Asm	1

P4 timings:
509     cycles for movdqa (aligned 16)
1098    cycles for movdqu
1148    cycles for rep movsd
1300    cycles for fild/fistp
3330    cycles for movlps/movhps

465     cycles for movdqa (aligned 16)
1096    cycles for movdqu
1149    cycles for rep movsd
1295    cycles for fild/fistp
3328    cycles for movlps/movhps

467     cycles for movdqa (aligned 16)
1090    cycles for movdqu
1145    cycles for rep movsd
1299    cycles for fild/fistp
3335    cycles for movlps/movhps

467     cycles for movdqa (aligned 16)
1090    cycles for movdqu
1139    cycles for rep movsd
1297    cycles for fild/fistp
3325    cycles for movlps/movhps

467     cycles for movdqa (aligned 16)
1089    cycles for movdqu
1140    cycles for rep movsd
1299    cycles for fild/fistp
3334    cycles for movlps/movhps